// Copyright (c) 1999-2000 Jean-Claude Wippler <jcw@equi4.com>
//
// Interface to MD5 (RSA Data Security, Inc. MD5 Message-Digest Algorithm)

#include "wcommon.h"

extern "C"
{
    #include "md5.h"
    #include <stdio.h>
}

    // THIS STUFF SHOULD USE ROPES

/////////////////////////////////////////////////////////////////////////////

class wMD5 : public wObject
{
    MD5_CTX _md;

public:
    wMD5 ();

        // native interface
    void Update(const void* ptr_, int len_);
    wRef Digest();

        // generic interface
    virtual wRef Call(wCallFrame& cf_);
};

/////////////////////////////////////////////////////////////////////////////

wMD5::wMD5 ()
{
    MD5Init(&_md);
}

void wMD5::Update(const void* ptr_, int len_)
{ 
    MD5Update(&_md, (unsigned char *) ptr_, len_);
}

wRef wMD5::Digest()
{ 
    MD5_CTX dup = _md;
    unsigned char buf [16];
    MD5Final(buf, &dup);
    return wRef (buf, sizeof buf);
}

wRef wMD5::Call(wCallFrame& cf_)
{
    static const char* cmds[] = {
        "update", "digest", 0
    };

    switch (cf_.Lookup(cmds))
    {
    case 0: // update string
        {
            wRef input = ++cf_;
            Update(input, input.ByteLength());
            break;
        }
    case 1: // digest -> value
        {
            return Digest();
        }
    default:
        {
            return wObject::Call(cf_);
        }
    }

    return wRef ();
}

/////////////////////////////////////////////////////////////////////////////

extern wRef wMD5Cmd(wCallFrame& cf_)
{
    return cf_.RegisterCmd(new wMD5);
}
